<template>
  <div class="prk-order__container prk-order--step-one">
      <popupEror 
         v-if="responsEror && clousPopup" 
         :eror="responsEror"
         v-on:clous-popup="clousPopup = false;noScroll();"
      />
      <div class="row prk-order__inner">
         <div class="col-lg-6 d-flex">
            <form class="h-100" @submit.stop.prevent>
               <div class="prk-order__inner-item h-100">
               <h2 class="prk-order__title">RÉSERVEZ EN TEMPS RÉEL VOTRE CONVOYAGE EN FRANCE ET EN EUROPE</h2>
               <div class="prk-order__first-form">
                   <div class="row prk-order__form-row">
                       <div class="prk-order__form-item col-md-6">
                           <label for="startAddress" class="prk-order__label">
                           Adresse de départ</label>
                           <div :class="{'prk-order__loader':googleRespons}">
                              <vue-google-autocomplete
                                  ref="startAddress"
                                  id="startAddress" 
                                  classname="prk-order__input prk-order__input--image"
                                  :class="{'prk-order__is-invalid':attemptSubmit && missingStartAddress}"
                                  placeholder=""
                                  v-on:placechanged="getAddressStart"
                                  v-on:inputChange="changesStartAddress"
                                  v-on:error="errorStartAdress"
                              >
                              </vue-google-autocomplete>
                           </div> 
                           <div class="prk-order__invalid" v-if="attemptSubmit && missingStartAddress">
                              Sélectionnez l'un des champs suggérés
                           </div>
                       </div>
                       <div class="prk-order__form-item col-md-6">
                           <label for="finishAddress" class="prk-order__label">Adresse d’arrivée</label>
                           <div :class="{'prk-order__loader':googleRespons}">
                              <vue-google-autocomplete
                                  ref="finishAddress"
                                  id="finishAddress" 
                                  classname="prk-order__input prk-order__input--image"
                                  :class="{'prk-order__is-invalid':attemptSubmit && missingFinishAddress}"
                                  placeholder=""
                                  v-on:placechanged="getAddressFinish"
                                  v-on:inputChange="changesFinishAddress"
                              >
                              </vue-google-autocomplete>
                              </div>   
                           <div class="prk-order__invalid" v-if="attemptSubmit && missingFinishAddress">
                              Sélectionnez l'un des champs suggérés
                           </div>
                       </div>
                       <div class="prk-order__form-item col-md-6">
                           <label class="prk-order__label">Type de véhicule</label>
                           <div :class="{'prk-order__multiselect-invalid': missingTypeCar && attemptSubmit}">
                            <multiselect 
                            v-model="postFormOne.typeCar" 
                            :options="type_car" 
                            :searchable="false" 
                            :show-labels="false" 
                            placeholder="Type de véhicule">
                            </multiselect>
                           </div> 
                       </div>
                       <div class="prk-order__form-item col-md-6">
                           <label class="prk-order__label">Options</label>
                           <div>
                              <multiselect 
                              v-model="postFormOne.optionCar" 
                              :options="option_car" 
                              :multiple="true"  
                              :close-on-select="false" 
                              :searchable="false" 
                              :clear-on-select="false" 
                              :preserve-search="false" 
                              placeholder="Options du convoyage">
                              </multiselect>
                           </div>
                       </div>
                       <div class="prk-order__form-item col-12">
                           <label class="prk-order__container-checkbox"> Rapporter un véhicule de reprise
                                <input v-model='postFormOne.restoringCar' type="checkbox">
                              <span class="prk-order__checkmark"></span>
                           </label>
                       </div>
                       <div class="col-12 text-center" >
                           <button 
                              type="submit" 
                              :class="{'prk-order__loader':loadRespons}"
                              class="prk-order__submit" 
                              :disabled="loadRespons || googleRespons || googleMapsInvalid"
                              @click.enter.prevent="onSubmit()? $emit('dataFormFirst', {postFormOne,responsData}) : null;">
                              CHERCHER
                           </button>   
                       </div>
                   </div>
               </div>
              </div> 
            </form>
         </div>
          <div class="col-lg-6 d-flex">
               <div class="prk-order__inner-item prk-order__inner-item--padding-plus">
                  <h2 class="prk-order__title">LES PLUS PARKOPOLY</h2>
                  <div class="prk-order__about-item prk-order__about-item-frist">
                     <div class="prk-order__subtitle prk-order--clor-red">
                        Service de porte à porte
                     </div>
                     <div class="prk-order__description font-bold">
                        Vous choisissez les adresses de départ et d’arrivée de votre convoyage
                     </div>
                  </div>
                  <div class="prk-order__about-item prk-order__about-item-second">
                     <div class="prk-order__subtitle prk-order--clor-red">
                        Prix tout compris
                     </div>
                     <div class="prk-order__description font-bold">
                        Assurance tous risques, péages, carburant et convoyage
                     </div>
                  </div>
                  <div class="prk-order__about-item prk-order__about-item-three">
                     <div class="prk-order__subtitle prk-order--clor-red">
                        Chauffeur professionnel
                     </div>
                     <div class="prk-order__description font-bold">
                        Un chauffeur professionnel, sélectionné et géolocalisé en permanence conduit votre véhicule sur tout le trajet
                     </div>
                  </div>
               </div>  
          </div>
      </div>
  </div>
</template>

<script>
import VueGoogleAutocomplete from 'vue-google-autocomplete'
import Multiselect from 'vue-multiselect'
import popupEror from './popupEror.vue'
import axios from 'axios'
export default {
  name: 'FormStepFirst',
   components: {
    Multiselect,
    popupEror,
    VueGoogleAutocomplete
  },
  data () {
    return {
        type_car: ['Compact', 'Moyenne', 'Familiale', 'SUV', 'Sportive', 'Utilitaire < 6m3', 'Utilitaire > 6m3'],
        option_car:['Mise en main','Lavage'],
        attemptSubmit: false,
        clousPopup: false,
        startAddressStr: '',
        finishAddressStr: '', 
        loadRespons: null,
        googleRespons: null,
        responsEror: false,
        googleMapsInvalid: false,
        postFormOne:{
            step: 1,
            startAddress: {nameAdress:'',lat:'',lng:''},
            finishAddress: {nameAdress:'',lat:'',lng:''},
            typeCar: [],
            optionCar: '',
            restoringCar: false
            },
         responsData:{
            distance: '',
            price:''
         }
    }
  },
  mounted() {
            this.$refs.startAddress.focus();
            this.$refs.finishAddress.focus();
   },
  methods: {
     /*Start Address */
     changesStartAddress() { 
        if(this.startAddressStr != document.querySelector('#startAddress').value){
           for(let key in this.postFormOne.startAddress){
            this.postFormOne.startAddress[key] = ''
         }
        } 
      },
     getAddressStart(addressData) {
         this.postFormOne.startAddress.nameAdress = `${addressData.street_number ? addressData.street_number + ', ' : ''} ${addressData.route ? addressData.route + ', ' : ''} ${addressData.locality ? addressData.locality + ', ' : ''} ${addressData.administrative_area_level_1 ? addressData.administrative_area_level_1 + ',' : ''} ${addressData.country ? addressData.country : ''}. `;
         this.postFormOne.startAddress.lat = addressData.latitude;
         this.postFormOne.startAddress.lng = addressData.longitude;
         this.startAddressStr = document.querySelector('#startAddress').value;
      },
      /*Finsih Address */
      changesFinishAddress() { 
        if(this.finishAddressStr != document.querySelector('#finishAddress').value){
           for(let key in this.postFormOne.finishAddress){
            this.postFormOne.finishAddress[key] = ''
         }
        } 
      },
     getAddressFinish(addressData) {
         this.postFormOne.finishAddress.nameAdress = `${addressData.street_number ? addressData.street_number + ', ' : ''} ${addressData.route ? addressData.route + ', ' : ''} ${addressData.locality ? addressData.locality + ', ' : ''} ${addressData.administrative_area_level_1 ? addressData.administrative_area_level_1 + ',' : ''} ${addressData.country ? addressData.country : ''}. `;
         this.postFormOne.finishAddress.lat = addressData.latitude;
         this.postFormOne.finishAddress.lng = addressData.longitude;
         this.finishAddressStr = document.querySelector('#finishAddress').value;
      },
     onSubmit(){
        this.attemptSubmit = true;
        if (this.missingStartAddress || this.missingTypeCar || this.missingFinishAddress){
            return false;
         }else{
            this.loadRespons = true; 
            axios({
                 method: 'post',
                 url: '/wp-admin/admin-ajax.php',
                 timeout: 60000, 
                 params: {
                    action: 'step_1',
                 },
                 data: {
                   body: JSON.stringify(this.postFormOne),
                 }
               })
               .then(response=>{
                  this.responsData.distance = response.data.distance;
                  this.responsData.price =response.data.price;
                  if(response.data.error){
                     this.responsEror = response.data.error;
                     this.clousPopup = true;
                  }else{
                     this.responsEror = false;
                  }
               })
               .catch(()=>{
                  this.responsEror = "Une erreur s'est produite, n'hésitez pas à contacter l'équipe Sales à contact@parkopoly.fr";
                  this.clousPopup = true;
               })
               .finally(()=>{
                  this.loadRespons = false;
               });
               
            return true;
         }
     },
     noScroll(){
       document.body.classList.remove('scroll-none');
    }
  },
  computed: {
    missingStartAddress(){ 
      return this.postFormOne.startAddress.nameAdress === ''; 
    },
    missingFinishAddress(){
        return this.postFormOne.finishAddress.nameAdress === ''; 
    },
    missingTypeCar() { 
      return this.postFormOne.typeCar.length === 0; 
    },
  },
  watch: {
     loadRespons(){
        return(!this.loadRespons &&  !this.responsEror? this.$emit('next-step'):null);
     }
  },
}
</script>
<style lang="stylus">
greenColor = #00af78
/*Helpers */
#prk-order-app .h-100 
   height 100%!important

#prk-order-app #startAddress
   background url(/wp-content/mu-plugins/online-order/assets/img/noun_Location.svg)10px 50% no-repeat

#prk-order-app #finishAddress
   background url(/wp-content/mu-plugins/online-order/assets/img/finish_adres.svg)10px 50% no-repeat

.font-bold
   font-weight 600

#prk-order-app .prk-order
   &__title 
      font-size 16px!important
      line-height 20px
      margin-bottom 20px
      font-weight 700

   &__label 
      display block
      font-size 14px
      color #000
      font-weight 600
      line-height 19px
      margin-bottom 15px

   &--clor-red 
       color #AF0037
#prk-order-app 
      & ::placeholder,
      & :-ms-input-placeholder,
      & ::-ms-input-placeholder
            color  #A8A8A8  

.prk-order
   &-app input::-webkit-outer-spin-button,
   &-app input::-webkit-inner-spin-button
      -webkit-appearance none
      -moz-appearance none
      appearance none
   #prk-order-app &__input ,
   #prk-order-app &__textarea
      padding 10px 20px
      width 100%
      margin-bottom 20px
      border 1px solid #707070
      background #fff
      border-radius 2px
      color #000
      font-size 14px
      -webkit-appearance none
      -moz-appearance none
      appearance none
      &--image
         padding-left 35px
      &--max-width
         max-width 140px
         text-align center
      &:focus
         outline none
   &__textarea
      max-height 115px
   &__subtitle 
       font-size 18px
       line-height 24px
       font-weight 600
       padding-bottom 10px

   #prk-order-app &__is-invalid,
   #prk-order-app &__multiselect-invalid .multiselect__tags,
   #prk-order-app &__invalid-checkbox &__checkmark
      border-color #c30404
      box-shadow inset 0 0 2px #c30404
      margin-bottom 5px!important

   #prk-order-app &__invalid
      color #c30404
      bottom 10px
      font-size 12px
      line-height 1
      margin-bottom 10px
      &--color
          color #c30404
   #prk-order-app &__invalid-checkbox  &__invalid
      margin-top 10px
      margin-bottom 0
   /*Basic stile */
   &__inner-item 
      padding 20px 0
      max-width 100%
      &--padding-plus
         padding-left 60px
   
   /*Icon form step one */
   &__about-item
      position relative
      &:not(:last-child)
         padding-bottom 50px
      &:before 
         content ""
         position absolute
         width 42px
         height 42px
         box-shadow 0 3px 6px #54606E
         background-color #54606E
         background-repeat no-repeat
         background-position center center
         border-radius 50%
         left -60px
         transition ease .5s
         top 5px
      &:hover:before
            transform scale3d(1.2, 1.2, 1.2)
      &:focus:before
            outline none
            transform scale3d(1.2, 1.2, 1.2)
      &-frist
         &:before 
            background-image url('/wp-content/mu-plugins/online-order/assets/img/noun_click.svg')
      &-second
         &:before 
            background-image url('/wp-content/mu-plugins/online-order/assets/img/noun_Home.svg')
      &-three
         &:before 
            background-image url('/wp-content/mu-plugins/online-order/assets/img/noun_Piggy_Bank.svg')

   /*checkbox */
   #prk-order-app  &__container-checkbox
      position relative

      display block

      margin-bottom 30px
      padding-left 45px

      cursor pointer
      -webkit-user-select none
      -moz-user-select none
      -ms-user-select none
      user-select none

   &__container-checkbox input 
      position absolute

      width 0
      height 0

      cursor pointer

      opacity 0

   &__checkmark, 
   &__radio
      position absolute
      top 0
      left 0

      width 25px
      height 25px

      border 1px solid #707070
      border-radius 3px


   &__container-checkbox:hover input ~ &__checkmark 
      background-color #ddd

   &__container-checkbox input:checked ~ &__checkmark 
      background-color greenColor

   &__checkmark:after
      position absolute
      display none
      content ""
      

   &__container-checkbox input:checked ~ &__checkmark:after,
   &__container-checkbox input:checked ~ &__radio:after 
      display block

   &__container-checkbox &__checkmark:after 
      top 2px
      left 7px

      width 10px
      height 15px

      -webkit-transform rotate(45deg)
      -ms-transform rotate(45deg)
      transform rotate(45deg)

      border solid white
      border-width 0 3px 3px 0
   /*Radio Button */
   &__radio
      border-radius 50%
   &__radio:after 
      position absolute
      display none
      content ""
      background-color #54606E;
      width 15px
      height 15px
      border-radius 50%
      
   &__container-checkbox:hover &__radio:after,
   &__container-checkbox input:checked ~ &__radio:after
      display block

   &__container-checkbox &__radio
      top 2px
      left 7px
      width 25px
      height 25px
      display flex
      justify-content center
      align-items center

   /* Button */
   &__submit,
   &__button
      font-size 16px
      line-height 28px
      background greenColor
      color #fff
      padding 10px 15px
      min-width 100%
      max-width 100%
      border 1px solid greenColor
      border-radius 2px
      display inline-block
      cursor: pointer;
      margin-bottom: 15px
      box-shadow 0 3px 6px #ddd
      &:hover,
      &:hover
         opacity 0.8
      &:focus,
      &:focus
         outline none
         background #00AF78
      &--next,
      &--prev 
         margin-left auto
         margin-right auto  
      &--no-bg
         color #00AF78
         background none
         box-shadow none
         border none
         &:focus
            outline none
            background none
   &--step-one &__button,
   &--step-one &__submit
      min-width 230px
      
   &__action
      display flex
      flex-wrap wrap
      margin 20px 0 10px 
      flex-direction: column;
   /*Loader */
   &__loader
      position relative
      &:after
         content ""
         z-index 2
         position absolute
         background-size: 25px
         width 25px
         right 15px
         top: 10px
         height: 25px
         background url(https://verol.net/templates/verol-design/img/preloader.gif) center / 25px no-repeat

   /*devider */

   #prk-order-app &__divider 
      border .5px solid #707070
      margin-bottom 35px

   /*border*/
   #prk-order-app &--border-right
      position relative
      &:after
         position absolute
         right 0
         height 100%
         width 0.5px
         background #707070
         content ""
         top 0
         bottom 0
   &--border-md-right
      &:after
         display none
@keyframes useRotate 
    0% 
        -webkit-transform-origin center
        transform-origin center
        -webkit-transform rotate(200deg)
        transform rotate(200deg) scale3d(1.2, 1.2, 1.2)
    to 
        -webkit-transform-origin center
        transform-origin center
        -webkit-transform rotate(0)
        transform rotate(0) scale3d(1)

@media (min-width: 480px)
   .prk-order
      /* Button */
      &__submit,
      &__button
         min-width 290px
         font-size 20px
         padding 10px 50px

@media (min-width: 768px)
   .prk-order
      &__inner-item 
         padding 40px 20px
         box-shadow 0 3px 6px #ddd
         &--padding-plus
            padding-left 110px
            padding-right 80px
      #prk-order-app &__input ,
      #prk-order-app &__textarea
         margin-bottom 30px
      &__action
         margin 30px 0 10px
      &--border-md-right
         &:after
            display block
   #prk-order-app .prk-order
      &__title 
         font-size 20px!important
         line-height 30px
         margin-bottom 30px

</style>
